<?php
// $Id: edset_data.php,v 1.7 2010/07/08 13:47:46 calicant Exp $

require "adm/lib/setup.php";
require "adm/lib/test_auth.php";

$last_login_info = "";

if (file_exists(PRISCILLA_LOCAL_PATH."modules/security/lib/security_class.php"))
{
    require_once PRISCILLA_LOCAL_PATH."modules/security/lib/security_class.php";
    $sec_obj = new security($connh);
    $sec_prefs = $sec_obj->getSecurityPrefs();
}


    $error_pass_msg = '';

    if (!isset($_GET['login_tmp']))
    {
        $login_tmp = $_COOKIE['login'];
        $session_update = true;
        $usertable = $PRISCILLA_SESSION->getvalue('usertable');
    }
    else
    {
        $login_tmp = $_GET['login_tmp'];
        $query = "SELECT * FROM user WHERE username='$login_tmp'";
        $rs = $connh->Execute($query) or die("ERROR: $query<br />".$connh->ErrorMsg());
        $usertable = $rs->fields;
        $session_update = false;
    }



    // vediamo se il caso di andare a vedere login buoni o falliti
    if ($sec_prefs['security_login_old_info'] && $sec_prefs['security_login_log'] && $sec_prefs['security_login_failed_log']) {


        $dbquery = "SELECT * FROM `security_failed_login` WHERE `username` = '" . $usertable['username'] . "' ORDER BY id DESC LIMIT 1";


        $rslfailed = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());

        $lastlogininfo = array();

        if ($rslfailed->RecordCount())
            $lastlogininfo = $rslfailed->fields;

        // alla ricerca di un login buono
        $dbquery = "SELECT * FROM `security_good_login` WHERE `uid` = '" . $usertable['id']  . "' ORDER BY id DESC";

        $rslgood = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());

        if ($rslgood->RecordCount() > 1) {
            $fake = $rslgood->fields;
            $rslgood->MoveNext();
            $lastlogininfo_temp = $rslgood->fields;
        }

        if (isset($lastlogininfo_temp['logdate'])) {

            // se non abbiamo errori precedenti
            if (!$rslfailed->RecordCount())
                $lastlogininfo = $lastlogininfo_temp;
            else {
                // si mostra l'errore a meno che non ci sua un login buono piu' recente
                $daterror = $lastlogininfo['logdate'];
                $datelogin = $lastlogininfo_temp['logdate'];

                // echo "d1 = $daterror || d2 = $datelogin<br />\n";

                if ($datelogin > $daterror)
                    $lastlogininfo = $lastlogininfo_temp;
            } 
        }

        if (isset($lastlogininfo['logdate'])) {

            $last_login_info .= "<br />";

            if (!isset($lastlogininfo['uid']))
                $last_login_info .= "ERROR LOGIN: ";
            else
                $last_login_info .= "Login: ";

            $last_login_info .= $lastlogininfo['logdate'] . ", " . $lastlogininfo['host'] . "<br />(" . $lastlogininfo['terminal'] . ")";
        } // if (isset

    } // if ($sec_prefs

   
    $dbquery = "SELECT password FROM user WHERE username = '$login_tmp'";
    $tps = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());
    $usertable['password'] = $tps->fields('password');

    if ($save_indb)
    {

        $good_password = true;

        // passlen pari a 40 sono password crittate
        // le altre password sono lunghe max 32 caratteri
        // c'e' comunque un controllo via javascript
        // in compilazione form

        $passlen = strlen($pass1);

        // un controllo sulla bonta' della password
        // qui se uno mette una password di 40 caratteri bypassa i controlli di security password
        // ma in questo caso gliela passiamo ;)
        // ovvero un input di 40 caratteri discrimina password crittate

        if ($passlen != 40)  {
            if (!isValidPassword($pass1))
                $good_password = false;
        }

        
        if (($pass1!='' && $pass2!='') && ($pass1==$pass2) && $good_password)
        {
            // eventuale crittazione di password
            if ($passlen != 40) {
                $rscrypt = $connh->Execute("SELECT SHA1('" . $pass1 . "') as cryptedpass") or die ("Fatal Error: SHA1 function not available.\n");
                $pass1 = $rscrypt->fields('cryptedpass');
            }

            $query = "UPDATE user SET lingua='$lingua', skin='$skin_', password='$pass1', email='$email', at_login='$at_login', pupwidth='$pupwidth', pupheight='$pupheight' WHERE username='$login_tmp'";
            $rs = $connh->Execute($query);

            // ricarico nuove impostazioni
            $dbquery = "SELECT * FROM user WHERE username='$login_tmp'";
            $rowrs = $connh->Execute($dbquery);
            $usertable = $rowrs->fields;

            // niente password nella sessione
            $tempp = $usertable['password'];
            $usertable['password'] = 'MASKED';
            if ($_POST[session_update]) {
                $PRISCILLA_SESSION->add('usertable', $usertable);
                $PRISCILLA_SESSION->add('sk', $usertable["skin"]);
            }
            $usertable['password'] = $tempp;

            echo "<script language=\"javascript\" type=\"text/javascript\">window.opener.location.reload();</script>";
        }
        else {
            if ($lingua != '')
            $tl = $lingua;
            else if ($usertable[lingua] != '')
            $tl = $usertable[lingua];
            else if ($lang != '')
            $tl = $lang;
            else
            $tl = 'ita';


            require "tools/lang/$tl/error.diz";
            require "tools/lang/$tl/adm_dialog.diz";

            if (!$good_password)
                $error_pass_msg =
                    adm_user_dummy_password .
                    "<br />" .
                    adm_user_dummy_password_note .
                    "<br />";
            else
                $error_pass_msg = "<br /><div align=\"center\" class=\"insert_message\"><strong>err_ins_passw</strong></div><br />\n";
        }
    }

    $skin = $PRISCILLA_SESSION->getvalue('sk');
    $lang = $PRISCILLA_SESSION->getvalue('lingua');

    require_once "tools/lang/$lang/dialog.diz";
    require "tools/lang/$lang/error.diz";
    require_once "tools/lang/$lang/adm_dialog.diz";

    include PRISCILLA_LOCAL_PATH."adm/include/html_head.inc.php";
    print "<title>".dialog_custom_tit."</title>";
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"adm/skin/$skin/default.css\">";
    print "<!--[if lte IE 7]>
			<link rel=\"stylesheet\" type=\"text/css\" href=\"adm/skin/ie6.css\" />
		<![endif]-->";
    print "</head>";
    include("adm/skin/$skin/body.inc");
    include("adm/include/head_popup.inc.php");

    if ($error_pass_msg != '')
        echo $error_pass_msg;

?>
<table class="table_border" width="<? include("adm/include/dim_all.inc.php"); ?>" align="center" cellpadding="3" cellspacing="1" border="0">
<tr>
    <th colspan="4" class="table_tit"><? print dialog_custom_tt; ?> <span class="insert_message"><? echo strtoupper($login_tmp) . "</span>" . $last_login_info; ?></th>
</tr><form method="post"><input type="hidden" name="save_indb" value="true" />
    <input type="hidden" name="session_update" value="<? echo $session_update; ?>"><tr>
    <td width="21%" class="insert_voice_dark"><? print dialog_gen_lang; ?></td>
    <td width="29%" class="insert_voice_dark"><select style="width:100%" name="lingua" class="insert_area">
    <option value="<? echo $usertable[lingua];?>"><? echo $usertable[lingua];?></option>
    <?
    clearstatcache();
    $a_files = array();
    if ($dir = @opendir('tools/lang')) {
        while ($file = readdir($dir)) {
            if (($file != ".") && ($file != "..") && ($file != "CVS"))
                $a_files[] = $file;
        }
        sort($a_files);
        foreach ($a_files as $file)
            echo "<option value=\"$file\">$file</option>\n";
        closedir($dir);

    }
    ?>  </select></td>
    <td width="21%" class="insert_voice_dark"><? print dialog_gen_skin; ?></td>
    <td width="29%" class="insert_voice_dark"><select style="width:100%" name="skin_" class="insert_area">
    <?
    echo "<option value=\"$usertable[skin]\">$usertable[skin]</option>";
    echo "<option value=\"\"></option>";
    clearstatcache();
    $a_files = array();
    if ($dir = @opendir('adm/skin/'))
    {
        while ($file = readdir($dir)) {
            if (($file != ".") && ($file != "..") && ($file != "CVS") && ($file != "ie6.css"))
                $a_files[] = $file;
        }
        sort($a_files);
        foreach ($a_files as $file)
            echo "<option value=\"$file\">$file</option>\n";
        closedir($dir);
    }
    ?></select></td>
</tr><tr>
    <td class="insert_voice" colspan="4"><? print dialog_gen_crypt_pwd; ?></td>
</tr><tr>
    <td class="insert_voice"><? print dialog_gen_pwd; ?></td>
    <td class="insert_voice"><input onChange="if (this.value.length > 32) { alert('MAX LEN: 32'); this.value=''; this.focus(); }" type="password" size="26" maxlength="40" name="pass1" value="<? echo $usertable[password]; ?>" class="insert_area" style="width:100%"></td>
    <td class="insert_voice"><? print dialog_gen_pwd_rpt; ?></td>
    <td class="insert_voice"><input type="password" size="26" maxlength="40" name="pass2" value="<? echo $usertable[password]; ?>" class="insert_area" style="width:100%"></td>
</tr><tr>
    <td class="insert_voice_dark"><? print dialog_gen_email; ?></td>
    <td class="insert_voice_dark" colspan=3><input type="text" size="26" maxlength="40" name="email" value="<? echo $usertable[email]; ?>" class="insert_area" style="width:100%"></td>
</tr><tr>
    <td class="insert_voice"><? print dialog_gen_atlogin; ?></td>
    <td class="insert_voice" colspan=3>
    <select name="at_login" style="width:100%" class="insert_area">
    <option value="<? echo $usertable[at_login]; ?>">
    <?
    $COOKIESEZ = "index.php?id=";
    // albero del sito
    if ($usertable[at_login] == "tools.php?action=show_tree&id_node=1")
        echo adm_voice_mappasito;
    // varie pagine adm
    else if ($usertable[at_login] == "adm/adm_schedario.phtml")
        echo strtolower(adm_stool_skeduler);
    else if ($usertable[at_login] == "adm/adm_forum.phtml")
        echo strtolower(adm_user_prvadm_forum);
    else if ($usertable[at_login] == "adm/adm_thebox.phtml")
        echo strtolower(adm_user_prvadm_tbx);
    else if ($usertable[at_login] == "adm/adm_community.phtml")
        echo strtolower(adm_user_prvadm_comm);
    else if ($usertable[at_login] == "adm/adm_sondaggi.phtml")
        echo strtolower(adm_user_prvadm_pool);
    else if ($usertable[at_login] == "adm/adm_prenotazioni.phtml")
        echo strtolower(adm_user_prvadm_booki);
    else if ($usertable[at_login] == "adm/adm_search.phtml")
        echo strtolower(adm_user_prvadm_search);
    else if ($usertable[at_login] == "adm/adm_catalogo.phtml")
        echo strtolower(adm_user_prvadm_cat);
    // pagine per redattori livello 0
    else if ($usertable[at_login] == "adm/index.php")
        echo strtolower(adm_voice_tabellebackup);
    else if ($usertable[at_login] == "adm/adm_user.phtml")
        echo strtolower(adm_level3_tt_admuser1);
    else if ($usertable[at_login] == "adm/adm_immagini.phtml")
        echo strtolower(adm_img_tt_ins);
    else if ($usertable[at_login] == "adm/adm_seditor.phtml")
        echo strtolower(pan_mt_editor);
    // il nome della sezione
    else if (substr($usertable[at_login], 0, strlen($COOKIESEZ)) == $COOKIESEZ) {
        $my_id_sezione = substr($usertable[at_login], strlen($COOKIESEZ), 255);
        if (is_numeric($my_id_sezione)) {
            $dbquery = "SELECT sezione FROM node WHERE id='$my_id_sezione'";
            $rowsez = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());
            if ($rowsez->RecordCount() > 0) {
                if (trim($rowsez->fields('sezione')) != '')
                    echo $rowsez->fields('sezione');
                else echo $usertable[at_login];
            }
            else echo $usertable[at_login];
        } else echo $usertable[at_login];
    }
    // altrimenti gli schietti numeri
    else
        echo $usertable[at_login];

    ?>
    </option>
    <?
    echo "<option value=\"tools.php?action=show_tree&id_node=1\">". adm_voice_mappasito . "</option>";
    echo "<optgroup label=\"".adm_voice_sezioni."\">";
    $dbquery = "SELECT id,sezione FROM node WHERE id_user='$usertable[username]' ORDER BY sezione";
    $rowrs = $connh->Execute($dbquery);
    while (!$rowrs->EOF)
    {
        $row = $rowrs->fields;
        echo "<option value=\"index.php?id=$row[id]\">$row[sezione]</option>\n";
        $rowrs->MoveNext();
    }
    echo "</optgroup>";
    if ($usertable[adm] == 'si')
    {
        echo "<optgroup label=\"".adm_voice_page_adm."\">";
        $dbquery = "SELECT * FROM user_adm WHERE id='$usertable[id]'";
        $rowrs = $connh->Execute($dbquery);
        while (!$rowrs->EOF)
        {
            $row = $rowrs->fields;
            if ($row[adm_schedario] == 'si')
                echo "<option value=\"adm/adm_schedario.phtml\">" . strtolower(adm_stool_skeduler) . "</option>\n";
            if ($row[adm_forum] == 'si')
                echo "<option value=\"adm/adm_forum.phtml\">" . strtolower(adm_user_prvadm_forum) . "</option>\n";
            if ($row[adm_thebox] == 'si')
                echo "<option value=\"adm/adm_thebox.phtml\">" . strtolower(adm_user_prvadm_tbx) . "</option>\n";
            if ($row[adm_community] == 'si')
                echo "<option value=\"adm/adm_community.phtml\">" . strtolower(adm_user_prvadm_comm) . "</option>\n";
            if ($row[adm_sondaggi] == 'si')
                echo "<option value=\"adm/adm_sondaggi.phtml\">" . strtolower(adm_user_prvadm_pool) . "</option>\n";
            if ($row[adm_prenotazioni] == 'si')
                echo "<option value=\"adm/adm_prenotazioni.phtml\">" . strtolower(adm_user_prvadm_booki) . "</option>\n";
            if ($row[adm_search] == 'si')
                echo "<option value=\"adm/adm_search.phtml\">" . strtolower(adm_user_prvadm_search) . "</option>\n";
            if ($row[adm_catalogo] == 'si')
                echo "<option value=\"adm/adm_catalogo.phtml\">" . strtolower(adm_user_prvadm_cat) . "</option>\n";

            $rowrs->MoveNext();
        }
    }
    if ($usertable[livello] == 0)
    {
        echo "<option value=\"adm/index.php\">" . strtolower(adm_voice_tabellebackup) . "</option>
        <option value=\"adm/adm_user.phtml\">" . strtolower(adm_level3_tt_admuser1) . "</option>
        <option value=\"adm/adm_immagini.phtml\">" . strtolower(adm_img_tt_ins) . "</option>
        <option value=\"adm/adm_seditor.phtml\">" . strtolower(pan_mt_editor) . "</option>";
    }
    ?>
    </optgroup>
    </select>
    </td>
    </tr><tr>
    <th colspan="4" class="table_sez"><?php echo dialog_edset_data_popup; ?></th>
</tr><form method="post"><input type="hidden" name="save_indb" value="true" /><tr>
    <td width="21%" class="insert_voice_dark"><?php echo dialog_gen_width; ?></td>
    <td class="insert_voice_dark"><input type="text" size="26" maxlength="40" name="pupwidth" value="<? echo $usertable[pupwidth]; ?>" class="insert_area" style="width:100%"></td>
    <td width="21%" class="insert_voice_dark"><?php echo dialog_gen_height; ?></td>
    <td class="insert_voice_dark"><input type="text" size="26" maxlength="40" name="pupheight" value="<? echo $usertable[pupheight]; ?>" class="insert_area" style="width:100%"></td>
</tr><tr>
    <td colspan="4" align="center" class="button_out"><input type="submit" value="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<? echo pan_save?>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" class="button_in awesome">
</tr></table><br />
<?
    include ('adm/include/closewin.js');
?>
<?php
    include("adm/include/menu_setup.inc.php");
    include("adm/include/about_root.inc.php");
?>
</body></html>
