<?php

require_once "adm/lib/setup.php";
// estraggo i dati dell'utente (per personalizzazioni)
$usertable = $PRISCILLA_SESSION->getvalue('usertable');
if ($usertable[skin] != '') $skin = $usertable[skin];
if ($usertable[lingua] != '') $lang = $usertable[lingua];

require "tools/lang/$lang/dialog.diz";
require "modules/catalogo/lang/$lang/catalogo.diz";
$swaplang = true;
if (file_exists("modules/swaplang/lib/swaplang.lib.php"))
    require_once "modules/swaplang/lib/swaplang.lib.php";
else
    $swaplang = false;

$content_table = 'catalogo_content';
$langstruct = array(); $langlabels = array();
if ($swaplang) {
    // se l'utente ha impostato una lingua (tabella di contenuto) diversa
    getLanguagesStruct($langslabels, $langstruct);
    $lang = getlLangFromContent($_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang_content'), $langstruct);
    if ($_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang_content') != '' && $lang != SWAPLANG_DEFAULT_LANG)
        $content_table = 'catalogo_content_lang'.$lang;
}

if ($action == 'cat_del')
{
    $query = "SELECT nome FROM catalogo WHERE id='$gid'";
    $rsc = $connh->Execute($query) or die("ERR: $query<br />".$connh->ErrorMsg());
    $query = "SELECT id_image FROM $content_table WHERE id='$id'";
    $rss = $connh->Execute($query) or die("ERR: $query<br />".$connh->ErrorMsg());

    $connh->Execute("DELETE FROM catalogo_content WHERE id='$id'") or die("ERR: $query<br />".$connh->ErrorMsg());
    if (count($langstruct['catalogo_content']))
    foreach ($langstruct['catalogo_content'] as $table => $lang) {
        $connh->Execute("DELETE FROM $table WHERE id='$id'") or die("ERR: $query<br />".$connh->ErrorMsg());
    }

    if ($rss->fields('id_image') != 0)
    {
        $rsi = $connh->Execute("SELECT nome FROM catalogo_immagini WHERE id_image='".$rss->fields('id_image')."'") or die("ERR: $query<br />".$connh->ErrorMsg());
        $rs = $connh->Execute("DELETE FROM catalogo_immagini WHERE id_image='".$rss->fields('id_image')."'") or die("ERR: $query<br />".$connh->ErrorMsg());
        @unlink("catalogo/".$rsc->fields('nome')."/pix/".$rsi->fields('nome'));
        @unlink("catalogo/".$rsc->fields('nome')."/mini/".$rsi->fields('nome'));
        @unlink("catalogo/".$rsc->fields('nome')."/medium/".$rsi->fields('nome'));
        @unlink("catalogo/".$rsc->fields('nome')."/large/".$rsi->fields('nome'));
    }
    header ("Location: index.php?id=$idp&cat_vis_start=$cat_vis_start");
}

if ($action == 'cat_sav')
{
    if ($_POST[link_ext] != '') $_POST['link'] = $_POST[link_ext];
    unset($_POST[link_ext]);
    foreach ($_POST as $key=>$val)
    {
        if ($key != 'id' and $key != 'action' and $key != 'idp' and $key != 'gid' and $key != 'hits' and $key != 'cat_vis_start' and $key != 'da_mese' and $key != 'da_giorno' and $key != 'da_anno' and $key != 'a_mese' and $key != 'a_giorno' and $key != 'a_anno' and $key != 'salvaerimani' and $key != 'salvaetorna')
        {
            $val = htmlspecialchars(stripslashes($val));
            if (strstr($key, "__DATE__"))
            {
                $date_tok = substr($key, 8, 1);
                $date_fieldname = substr($key, 10);
                $tokdate[$date_fieldname][$date_tok] = $val;
            }
            else $param[$key] = $val;
        }
    }
    
    if (count($tokdate) > 0)
    {
        foreach ($tokdate as $date_fieldname => $toks)
        {
            foreach ($toks as $dt => $v)
            {
                switch ($dt)
                {
                    case 'Y':
                    $y = $v;
                    break;
                    case 'D':
                    $d = $v;
                    break;
                    case 'M':
                    $m = $v;
                    break;
                }
            }
            $param[$date_fieldname] = $y.'-'.$m.'-'.$d;
        }
    }
    
    $rs = $connh->Execute("SELECT * FROM $content_table WHERE id='$id'") or die("ERR: $query<br />".$connh->ErrorMsg());
    $query = $connh->getUpdateSQL($rs, $param, $magicq=true) or die("<br />errore generazione update query");

    if (count($param) > 0)
        $rs = $connh->Execute($query) or die("ERR: $query<br />".$connh->ErrorMsg());
    if (strlen($da_mese) < 2) $da_mese = "0".$da_mese;
    if (strlen($da_giorno) < 2) $da_giorno = "0".$da_giorno;
    if (strlen($a_mese) < 2) $a_mese = "0".$a_mese;
    if (strlen($a_giorno) < 2) $a_giorno = "0".$a_giorno;
    $da = $da_anno.$da_mese.$da_giorno;
    $a = $a_anno.$a_mese.$a_giorno;
    $rs = $connh->Execute("UPDATE $content_table SET da='$da', a='$a' WHERE id='$id'");

    if ($salvaetorna)
        if ($idp) header ("Location: index.php?id=$idp&cat_vis_start=$cat_vis_start");
        else echo "<script language=\"javascript\" type=\"text/javascript\">window.close();</script>";

    elseif ($salvaerimani) $action = 'cat_mod';
}

// piglio l'immagine corrente
if ($action == 'cat_mod')
{
    if ($chgid != '')
    {
        $gid = $chgid;
        $query_where = "WHERE gid=$gid";
    }
    else $query_where = "WHERE id=$id";
    $query = "SELECT * FROM $content_table $query_where";
    $crs = $connh->Execute($query) or die("<br />ERROR:$query<br />".$connh->ErrorMsg());
    $crow = $crs->fields;

    // correzione per campi data
    // qui assai delicato perche' questa tabella non e' in aggiornamento
    // se non abbiamo un timestamp procuriamo che lo sia

    $crow['da'] = str_replace(' ', '', str_replace(':', '', str_replace('-', '', $crow['da'])));
    $crow['a'] = str_replace(' ', '', str_replace(':', '', str_replace('-', '', $crow['a'])));
    
    if (is_array($crow))
    {
        if ($crow[id_image] != '' and $crow[id_image] != 0)
        {
            $query = "SELECT * FROM catalogo_immagini WHERE id_image='$crow[id_image]'";
            $irs = $connh->Execute($query);
            $irow = $irs->fields;
        }
        // piglio id immagine successiva
        $query = "SELECT id FROM $content_table WHERE id > $crow[id] and gid = $gid ORDER BY id ASC";
        $rs = $connh->Execute($query) or die("<br />ERROR:$query<br />".$connh->ErrorMsg());
        $idsucc = $rs->fields('id');
        // piglio id immagine precedente
        $query = "SELECT id FROM $content_table WHERE id < $crow[id] and gid = $gid ORDER BY id DESC";
        $rs = $connh->Execute($query) or die("<br />ERROR:$query<br />".$connh->ErrorMsg());
        $idprec = $rs->fields('id');

        if ($crow[da] != '0000000000')
        {
            ereg("([0-9]{4})([0-9]{2})([0-9]{2})", $crow[da],$regs);
            $crow[da_giorno]=$regs[3];
            $crow[da_mese]=$regs[2];
            $crow[da_anno]=$regs[1];
        }
        else $crow[da]='';

        if ($crow[a] != '0000000000')
        {
            ereg("([0-9]{4})([0-9]{2})([0-9]{2})", $crow[a],$regs);
            $crow[a_giorno]=$regs[3];
            $crow[a_mese]=$regs[2];
            $crow[a_anno]=$regs[1];
        }
        else $crow[a]='';
    }
    else $action = 'cat_new';
}

$query = "SELECT * FROM catalogo WHERE id='$gid'";
$grs = $connh->Execute($query) or die("<br />ERROR:$query<br />".$connh->ErrorMsg());
$grow = $grs->fields;

if ($action == 'cat_new')
{
    $query = "INSERT INTO catalogo_content(gid,da,a) VALUES(".$gid.",'NULL','NULL')";
    $rs = $connh->Execute($query) or die("<br />ERROR:$query<br />".$connh->ErrorMsg());
    $id = $connh->Insert_ID();
    if (count($langstruct['catalogo_content']))
    foreach ($langstruct['catalogo_content'] as $table => $lang) {
        $connh->Execute("INSERT INTO $table(id,gid,da,a) VALUES(".$id.", ".$gid.",'NULL','NULL')");
    }

    $query = "SELECT * FROM $content_table WHERE id='$id' LIMIT 0,1";
    $crs = $connh->Execute($query) or die("<br />ERROR:$query<br />".$connh->ErrorMsg());
    $crow = $crs->fields;
    $query = "SELECT COUNT(id) AS c FROM $content_table WHERE gid='$gid'";
    $rs = $connh->Execute($query) or die("<br />ERROR:$query<br />".$connh->ErrorMsg());
    $tot_cont = $rs->fields('c');
    $ultimapag = ceil($tot_cont / ($grow[rowXTemplate] * $grow[colXTemplate]));
    $ultimapag = $ultimapag * ($grow[rowXTemplate] * $grow[colXTemplate]) - ($grow[rowXTemplate] * $grow[colXTemplate]);
}

//prendo tutti i campi utilizzati nel template

$reg_fields = array();
$rs = $connh->Execute("SELECT * FROM catalogo_fields WHERE INSTR(id_catalogo, '".$grow['id']."')");
while (!$rs->EOF) {
    $reg_fields[] = $rs->fields['nome'];
    $rs->MoveNext();
}

$template = $grow['template'];
$cf = 0;
$fields = array();
while (preg_match("/\{(\w+)\}/", $template, $regs))
{
    if ($regs[1] != 'image' && $regs[1] != 'image_mini' && $regs[1] != 'image_medium' && $regs[1] != 'image_large' && in_array($regs[1], $reg_fields)) {
        $fields[$cf] = $regs[1];
        $cf++;
    }
    $template = preg_replace("/\{".$regs[1]."\}/", "fatto", $template);
}
if ($grow[templatepop] != '')
{
    $template = $grow[templatepop];
    while (preg_match("/\{(\w+)\}/", $template, $regs))
    {
        if ($regs[1] != 'image' && $regs[1] != 'image_mini' && $regs[1] != 'image_medium' && $regs[1] != 'image_large' && !in_array($regs[1], $fields) && in_array($regs[1], $reg_fields)) {
            $fields[$cf] = $regs[1];
            $cf++;
        }
        $template = preg_replace("/\{".$regs[1]."\}/", "fatto", $template);
    }
}

//massimo rowspan 3 per il td immagine
if ($cf > 3) $cf = 3;

print "<html><head>";
include("adm/include/title.txt");
include("adm/include/OpenWnd.js");
print "<link rel=\"stylesheet\" type=\"text/css\" href=\"adm/skin/$skin/default.css\">";
print "<!--[if lte IE 7]>
			<link rel=\"stylesheet\" type=\"text/css\" href=\"adm/skin/ie6.css\" />
		<![endif]-->";
print "<meta http-equiv=\"content-type\" content=\"text/html; charset=".PRISCILLA_CHARSET."\" />";
print "</head>";
include("adm/skin/$skin/body.inc");
include("adm/include/head_root.inc.php");
?>
<table width="<? include("adm/include/dim_all.inc.php"); ?>" class="table_border" align="center" cellpadding="3" cellspacing="1" border="0">
<tr><form method="post">
<input type="hidden" name="action" value="cat_mod" />
    <th colspan="3" class="table_tit"><? echo catalog_ins_tit; ?> <select name="chgid" size="1" class="insert_voice" onchange="javascript:submit()"><?
    echo "<option value=\"$grow[id]\">$grow[nome]";
    if ($_COOKIE['login'] == 'superuser') $query_where = '';
    else $query_where = "WHERE id_user='".$_COOKIE['login']."'";
    $query = "SELECT id, nome FROM catalogo $query_where";
    $rs = $connh->Execute($query) or die("<br />ERROR:$query<br />".$connh->ErrorMsg());
    while(!$rs->EOF)
    {
        $row = $rs->fields;
        if ($row[id] != $grow[id])
            echo "<option value=\"$row[id]\">$row[nome]";
        $rs->MoveNext();
    }
    ?></select></th>
    <th class="button_out"><a class="awesome" href="tools.php?idp=<?=$idp?>&gid=<?=$gid?>&action=cat_new&cat_vis_start=0">#INSERISCI NUOVA SCHEDA#</a></th>
</tr></form>
<form method="post">
<input type="hidden" name="id" value="<?php echo $id; ?>">
<input type="hidden" name="idp" value="<?php echo $idp; ?>">
<input type="hidden" name="gid" value="<?php echo $gid; ?>">
<input type="hidden" name="cat_vis_start" value="<?php if ($ultimapag != '') echo $ultimapag; else echo $cat_vis_start; ?>">
<input type="hidden" name="action" value="cat_sav" />
<tr>
    <td align="center" width="25%" class="table_sez">ID</td>
    <td align="center" width="25%" class="table_sez"><? echo catalog_ins_vis; ?></td>
    <td align="center" colspan="2" class="table_sez">&nbsp;</td>
</tr><tr>
    <td align="center" width="25%" class="insert_voice"><? echo $crow[id]; ?></td>
    <td align="center" width="25%" class="insert_voice"><? echo dialog_gen_yes; ?><input type="radio" name="content_visible" value="1" <? if ($crow[content_visible] == 1) echo "checked"; ?>> <? echo dialog_gen_no; ?><input type="radio" name="content_visible" value="0" <? if ($crow[content_visible] == 0) echo "checked"; ?>></td>
    <td width="25%" align="center" nowrap class="button_out"><select name="da_giorno" size="1" class="insert_area"><?php
    echo "<option value=\"$crow[da_giorno]\">$crow[da_giorno]</option>";
    echo "<option value=\"\">--</option>";
    for($i=1;$i<=31;$i++)
    {
        echo "<option value=\"$i\">$i</option>";
    }
    ?></select><select name="da_mese" size="1" class="insert_area"><?php
    echo "<option value=\"$crow[da_mese]\">$crow[da_mese]</option>";
    echo "<option value=\"\">--</option>";
    for($i=1;$i<=12;$i++)
    {
        echo "<option value=\"$i\">$i</option>";
    }
    ?></select><input type="text" name="da_anno" maxlength="4" size="6" value="<?php echo $crow[da_anno];?>" class="insert_area"><br /><span class="insert_message"><? print dialog_date_in; ?></span></td>
    <td width="25%" align="center" nowrap class="button_out"><select name="a_giorno" size="1" class="insert_area"><?php
    echo "<option value=\"$crow[a_giorno]\">$crow[a_giorno]</option>";
    echo "<option value=\"\">--</option>";
    for($i=1;$i<=31;$i++)
    {
        echo "<option value=\"$i\">$i</option>";
    }
    ?></select><select name="a_mese" size="1" class="insert_area"><?php
    echo "<option value=\"$crow[a_mese]\">$crow[a_mese]</option>";
    echo "<option value=\"\">--</option>";
    for($i=1;$i<=12;$i++)
    {
        echo "<option value=\"$i\">$i</option>";
    }
    ?></select><input type="text" name="a_anno" maxlength="4" size="6" value="<?php echo $crow[a_anno]; ?>" class="insert_area"><br /><span class="insert_message"><? print dialog_date_out; ?></span></td>
</tr><tr>
    <td align="center" width="25%" class="table_sez"><? echo catalog_ins_imm; ?></td>
    <td align="center" width="25%" class="table_sez"><? echo catalog_ins_fie; ?></td>
    <td align="center" colspan="2" class="table_sez"><? echo catalog_ins_con; ?></td>
</tr><tr>
    <td align="center" valign="middle" <? if (count($fields) > 0) echo "rowspan=$cf"; ?> class="insert_voice">
    <div id="imgbox">
    <? if ($action == 'cat_mod' and $crow[id_image] != '' and $crow[id_image] != 0) {?>
    <a href="javascript:OpenWnd('modules/core/lib/a_foto.php?mode=catalogo&id_catalogo=<? echo $crow[gid]; ?>&idm=<? echo $crow[id_image]; ?>&azione=modifica')">
        <? if (file_exists("catalogo/".$grow[nome]."/mini/".$irow[nome])) {?><img src="catalogo/<? echo $grow[nome]."/mini/".$irow[nome];?>" border="0" />
        <? } else echo catalog_tag_noimm; ?></a>
    <? } ?>
    <? if ($action == 'cat_new' or $crow[id_image] == '' or $crow[id_image] == 0) {?>
    <a href="javascript:OpenWnd('modules/core/lib/a_foto.php?mode=catalogo&idp=<? echo $idp; ?>&id_content=<? echo $crow[id]; ?>&id_catalogo=<? echo $gid; ?>&cat_vis_start=<? echo $cat_vis_start; ?>')"><? echo catalog_ins_immins; ?></a><? } ?></div></td>
<?
$table = $connh->MetaColumns($content_table);
$i = 0;
if (count($fields) > 0)
foreach ($fields as $key=>$val)
{
    if ($val == 'link')
    {
        if ($i > 0) echo "<tr>";
        echo "<td width=\"25%\" class=\"insert_voice\">".$val."</td>
        <td class=\"insert_voice_dark\" ";
        if ($i >= 3) echo " colspan=\"3\"";
        else echo " colspan=\"2\"";
        echo "><select name=\"$val\" class=\"insert_area\">";
        if ($crow[$val] != '' && is_numeric($crow[$val]))
        {
            $query = "SELECT sezione FROM node WHERE id='".$crow[$val]."'";
            $rs = $connh->Execute($query);
            echo "<option value=\"".$crow[$val]."\">".$rs->fields('sezione');
            echo "<option value=\"\">------";
        }
        $query = "SELECT id, sezione FROM node ORDER BY sezione ASC";
        $rs = $connh->Execute($query);
        while (!$rs->EOF)
        {
            echo "<option value=\"".$rs->fields('id')."\">".$rs->fields('sezione');
            $rs->MoveNext();
        }
        echo "</select> http://<input type=\"text\" name=\"".$val."_ext\" value=\"";
        if (!is_numeric($crow[$val])) echo $crow[$val];
        echo "\" class=\"insert_voice\" size=\"25\"></td>
        </tr>";
    }
    else if (array_key_exists(strtoupper($val),$table))
    {
        $field = $table[strtoupper($val)];
        $type = $crs->MetaType($field->type);
        switch ($type)
        {
            case 'C':
                if ($i > 0) echo "<tr>";
                echo "
                <td width=\"25%\" class=\"insert_voice\">".$field->name."</td>
                <td class=\"insert_voice_dark\" ";
                if ($i >= 3) echo " colspan=\"3\"";
                else echo " colspan=\"2\"";
                echo "><input type=\"text\" name=\"".$field->name."\" maxlength=\"".$field->max_length."\" value=\"".stripslashes($crow[$field->name])."\" class=\"insert_voice\" style=\"width:100%\"></td>
            </tr>";
            break;
            case 'X':
                if ($i > 0) echo "<tr>";
                echo "
                <td width=\"25%\" class=\"insert_voice\">".$field->name."</td>
                <td class=\"insert_voice_dark\" colspan=\"";
                if ($i >= 3) echo "3\"";
                else echo "2\"";
                echo "><textarea name=\"".$field->name."\" rows=\"6\" cols=\"110\" style=\"width:100%\" class=\"insert_voice\">".str_replace("<br />","\r\n",stripslashes($crow[$field->name]))."</textarea></td>
            </tr>";
            break;
            case 'I':
                if ($i > 0) echo "<tr>";
                echo "
                <td width=\"25%\" class=\"insert_voice\">".$field->name."</td>
                <td class=\"insert_voice_dark\" colspan=\"";
                if ($i >= 3) echo "3\"";
                else echo "2\"";
                echo "><input type=\"text\" name=\"".$field->name."\" maxlength=\"".$field->max_length."\" value=\"".$crow[$field->name]."\" style=\"width:100%\" class=\"insert_voice\"></td>
            </tr>";
            break;
            case 'D':
                if ($crow[$field->name] != '') ereg("([0-9]{4})-([0-9]{2})-([0-9]{2})", $crow[$field->name], $dregs);
                
                if ($i > 0) echo "<tr>";
                echo "
                <td width=\"25%\" class=\"insert_voice\">".$field->name."</td>
                <td class=\"insert_voice_dark\" colspan=\"";
                if ($i >= 3) echo "3\"";
                else echo "2\"";
                echo "><select name=\"__DATE__D_".$field->name."\" class=\"insert_voice\">";
                for ($i = 1; $i <= 31; $i++)
                {
                    if ($i < 10) $i = '0'.$i;
                    echo "<option value=\"$i\"";
                    if ($dregs[3] == $i) echo "selected";
                    echo ">$i";
                }
                echo "</select>";
                echo "<select name=\"__DATE__M_".$field->name."\" class=\"insert_voice\">";
                for ($i = 1; $i <= 12; $i++)
                {
                    if ($i < 10) $i = '0'.$i;
                    echo "<option value=\"$i\"";
                    if ($dregs[2] == $i) echo "selected";
                    echo ">$i";
                }
                echo "</select>";
                echo "<input type=\"text\" name=\"__DATE__Y_".$field->name."\" maxlength=\"4\" size=\"4\" value=\"".$dregs[1]."\"  class=\"insert_voice\">";
            echo "</td></tr>";
            break;
        }
    }
    $i++;
}
else echo "<td colspan=\"3\" align=\"center\" class=\"insert_voice\">catalog_ins_voi</td></tr>";
?><tr>
    <td width="50%" colspan="2" align="left" class="table_sez"><? if ($idprec != '') {?><a href="tools.php?<? echo "idp=$idp&id=$idprec&gid=$gid&action=cat_mod&cat_vis_start=$cat_vis_start"; ?>"><strong><< <? echo catalog_ins_bac; ?></strong></a><? } else echo "&nbsp;";?></td>
    <td width="50%" colspan="2" align="right" class="table_sez"><? if ($idsucc != '') {?><a href="tools.php?<? echo "idp=$idp&id=$idsucc&gid=$gid&action=cat_mod&cat_vis_start=$cat_vis_start"; ?>"><strong><? echo catalog_ins_ava; ?> >></strong></a><? } else echo "&nbsp;";?></td>
</tr><tr>
    <td colspan="4" align="center" class="button_out"><input type="submit" name="salvaetorna" value="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<? print dialog_save_out; ?>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" class="button_in awesome">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="submit" name="salvaerimani" value="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<? print dialog_save_in; ?>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" class="button_in awesome"></td>
</tr>
</form>
</table>
