<?

// $Id: feeds_loop.inc.php,v 1.1 2009/04/29 11:12:10 calicant Exp $

require_once PRISCILLA_LOCAL_PATH . "modules/feeds/inc/config.inc.php";
require_once PRISCILLA_LOCAL_PATH . "modules/feeds/lib/feed_parser.php";

/**
 ** tag: feed
 ** desc: lettura di feeds RSS
 ** opt: url path http al feed xml (richiesto)
 ** opt: enconding set di caratteri da usare, se non fornito cerca di auto-capirlo
 ** opt: n numero di item da mostrare, se non fornito n = 5
 ** eg: <%feed url="http://www.repubblica.it/rss/politica/rss2.0.xml" n="3" encoding="utf-8"%>
 ** eg: <a href="{link}">{title}</a><br />
 ** eg: <%end%>
 **/
function feeds (&$connh, &$content, $risoluzione, &$PRISCILLA_SESSION, $options, &$publisher, $blocco) {

    if (trim($options["url"]) != "") {

        $conf = array('url' => $options["url"]);

        if (trim($options['encoding']) != "")
            $conf['encoding'] = $options['encoding'];

        $feed_parser = new feed_parser($conf);

        if (is_numeric($options['n']))
            $n = $options['n'];
        else
            $n = 5;

        $i = 0;
        while ($feed = $feed_parser->next_item()) {
            if ($i >= $n)
                break;

            $publisher->publish($blocco, $risoluzione, $feed);
            $i++;
        }
    }
}

?>
