<?
// $Id: module_body.inc.php,v 1.3 2010/07/06 12:15:57 riccardo Exp $
require_once "lib/test_auth.php";

if ($_COOKIE['login'] != 'superuser')
    die("Authentication failed");

require_once $priscilla_local_path . "modules/security/lib/security_class.php";
require_once $module_dir . "/lang/$lang/security.diz";
require_once $priscilla_local_path . "lib/util.inc.php";

function out_error ($msg) {

    if (trim($msg) == "")
        $msg = "Undefined Error";

    echo "<div align=\"center\" class=\"insert_message\"><strong>" . $msg . "</strong></div><br />\n"; 
}


$mysqlversion = getMysqlServerVersion ($dbhost, $dbuser, $dbpassw);

$debug = false;

$sec_prefs = array();
$sec_prefs['debug'] = $debug;

$sec = new Security ($connh, $sec_prefs);


if (isset($_POST['bPrefsSave'])) {
    
    $prefs = $_POST['prefs'];
  

    // un'operazione da fare una volta sola....

    $tempprefs = $sec->getSecurityPrefs();

    foreach ($sec->default_prefs as $p=>$v)
        if (!isset($prefs[$p]))
            $prefs[$p] = "0";
    $res = $sec->saveSecurityPrefs($prefs);

    if (!$res || $sec->haveError)
        out_error($sec->lastError);
}

$prefs = $sec->getSecurityPrefs();

if ($sec->haveError)
    out_error($sec->lastError);

if ($debug) {
    echo "<pre>";
    print_r($prefs);
    echo "</pre>";
}

$field_info = $connh->MetaColumns(SECURITY_TABLE_PREFS);

$security_prefs_title_l = SECURITY_PREFS_TITLE;

echo "<table align=\"center\">";

echo <<< END
    <form name="fsecurityprefs" action="$_SERVER[PHP_SELF]" method="POST">
    <table class="table_border" width="
END;
    include("include/dim_all.inc.php");
echo <<< END
    " align="center" cellpadding="3" cellspacing="1" border="0">
    <tr>
    <th colspan="2" class="table_tit" align="CENTER">$security_prefs_title_l</th>
    </tr>
END;



foreach ($field_info as $k=>$v) {

    $k = strtolower($k);

    if ($k == "id")
        continue;

    $type = $v->type;
    $langvar = strtoupper($k) . "_LABEL";
    $langdesc = "";
    eval("\$langdesc = " . $langvar . ";");

    if (trim($langdesc) == "")
        $langdesc = $k;

    if ($type == "int" && $k != 'security_passwd_expire_days') {
        $is_checked = $prefs[$k] ? "checked" : "";

        $fvalue = "<input class=\"insert_area\" type=\"checkbox\" name=\"prefs[$k]\" $is_checked value=\"1\" />\n";

    }
    else
        $fvalue = "<input class=\"insert_area\" type=\"text\" name=\"prefs[$k]\" value=\"" . $prefs[$k] . "\" />\n";

    echo "<tr><td class=\"table_sez\">" . $langdesc . "</td><td class=\"insert_voice\">" . $fvalue . "</td></tr>";
}

echo "<tr><td colspan=\"2\" class=\"button_out\" align=\"center\"><input class=\"button_in awesome\" type=\"submit\" name=\"bPrefsSave\" value=\"Salva le impostazioni\"></td></tr>";
echo "</table>\n</form>\n<br />\n";

?>

